/*
 * ASCD : copyright (c) Aley Keprt 1998-2001
 *
 * File printer.c : interface to BIOS printer routines
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <bios.h>

#include "z80.h" 
#include "printer.h"
#include "util.h" 


static FILE *printfile;


void PrinterClose() {
 if(printfile) fclose(printfile);
 printfile=0;
}


static void PrinterInit(void)
{
    /* Reset and Initialise the parallel port(s) */
/*
    int tmp = 0;

    return biosprint(_PRINTER_INIT, tmp, 0);
*/
 printfile=fopen("print.out","ab");
 OnQuit(PrinterClose,"printer close");
}


void PrinterWrite(int Port, uns8 Byte)
{
    /* Send the data Byte to the parallel port Port */
/*
    return biosprint(_PRINTER_WRITE, (int)Byte, Port);
*/
 if(!printfile) PrinterInit();
 if(printfile) putc(Byte,printfile);
}


int PrinterStatus(int Port)
{
    /* Return the Busy/Idle flag from the parallel port Port */
/*
    int Status;
    int tmp = 0;

    Status = biosprint(_PRINTER_STATUS, tmp, Port);
    return !(Status & 0x80);
*/
 static int status;

 status^=0x80;

 //always ready
 return 0;
}
