/* 
 * ASCD : copyright (c) Aley Keprt 1998-2001
 *
 * File samkbd.c : Universal include file of Sam keyboard handler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#define uskbd !cfg.uk


{
  switch (ks) {

		case SCANCODE_LEFTSHIFT:
    case SCANCODE_RIGHTSHIFT: and(0,1); shiftkey=pressed; break;

    //ctrl = joy fire or cntrl if no joy emulation on arrows
		case SCANCODE_LEFTCONTROL:
    case SCANCODE_RIGHTCONTROL:
      if(cfg.kempston && cfg.cursor && cfg.fuller & cfg.sinclair1 && cfg.sinclair2) {
        //no joy emulation on arrows --> cntrl
        and(8,1);
      } else {
        //joy emulation --> fire
        arrows.fire=pressed;
      }
      ctrlkey=pressed;
      break;

		case SCANCODE_SPACE:            and(7,1);    break;
		case SCANCODE_TAB:              and(3,0x40); break;
		case SCANCODE_ENTER:            and(6,1);    break;
		case SCANCODE_LEFTALT:          and(7,2);    break;
		case SCANCODE_RIGHTALT: 	      and(6,0x80); break;
		case SCANCODE_BACKSPACE:        and(4,0x80); break;
		case SCANCODE_ESCAPE:			      and(3,0x20); break;
    case SCANCODE_CAPSLOCK:         and(3,0x80); break;
    case SCANCODE_DELETE: and(0,1); and(4,0x80); break;
		case SCANCODE_CURSORBLOCKUP:    and(8,2); arrows.up=pressed; break;
		case SCANCODE_CURSORBLOCKDOWN:  and(8,4); arrows.down=pressed; break;
		case SCANCODE_CURSORBLOCKLEFT:  and(8,8); arrows.left=pressed; break;
		case SCANCODE_CURSORBLOCKRIGHT: and(8,0x10); arrows.right=pressed; break;
		case SCANCODE_KEYPADMINUS:			relshift; and(4,0x20); break;
		case SCANCODE_KEYPADPLUS:       relshift; and(4,0x40); break;
		case SCANCODE_KEYPADDIVIDE: 		and(0,1); and(4,0x20); break;
		case SCANCODE_KEYPADMULTIPLY:		and(0,1); and(4,0x40); break;

		/* the sam function keys are mapped onto the numeric keypad */
		case SCANCODE_KEYPAD0: and(5,0x80);	break;
		case SCANCODE_KEYPAD1: and(0,0x20);	break;
		case SCANCODE_KEYPAD2: and(0,0x40);	break;
		case SCANCODE_KEYPAD3: and(0,0x80);	break;
		case SCANCODE_KEYPAD4: and(1,0x20);	break;
		case SCANCODE_KEYPAD5: and(1,0x40);	break;
		case SCANCODE_KEYPAD6: and(1,0x80);	break;
		case SCANCODE_KEYPAD7: and(2,0x20);	break;
		case SCANCODE_KEYPAD8: and(2,0x40);	break;
		case SCANCODE_KEYPAD9: and(2,0x80);	break;

    /* tri klavesy vedle M */

		case SCANCODE_COMMA: //,<
			notshift and(7,0x20); ifelse {relshift; and(7,2); and(2,1);} break;

		case SCANCODE_PERIOD: //.>
			notshift and(7,0x40); ifelse {relshift; and(7,2); and(2,2);} break;

		case SCANCODE_SLASH: ///?
			notshift {
        and(0,1); and(4,0x20);
      }	ifelse {
				relshift; and(7,2); and(0,4);
			}
			break;

    /* dve klavesy vedle L */

		case SCANCODE_SEMICOLON: //;:
			notshift and(6,0x20); ifelse {relshift; and(6,0x40);} break;

		case SCANCODE_APOSTROPHE: //'" (US) or '@ (UK)
			notshift {
				and(0,1); and(4,8);
			}	ifelse {
        if(uskbd) {relshift; and(5,0x40);} else and(3,2);
			}
			break;

    /* tri klavesy vedle P */

		case SCANCODE_BRACKET_LEFT: //[{
			notshift {
				and(7,2); and(2,8);
			}	ifelse {
				relshift; and(7,2); and(1,8);
			}
			break;

		case SCANCODE_BRACKET_RIGHT: //]}
			notshift {
				and(7,2); and(2,0x10);
			}	ifelse {
				relshift; and(7,2); and(1,0x10);
			}
			break;

		case SCANCODE_BACKSLASH: //\| (US) or #~ (UK)
      if(uskbd) {
        notshift {
          and(0,1); and(7,0x80);
        } ifelse {
          relshift; and(7,2); and(4,2);
        }
      } else {
        notshift {and(0,1); and(3,4);} ifelse and(4,1);
      }
			break;

    /* dve klavesy vedle 0 */

		case SCANCODE_MINUS: //-_
			notshift and(4,0x20); ifelse and(5,0x20); break;

		case SCANCODE_EQUAL: //=+
			notshift and(5,0x20); ifelse {relshift; and(4,0x40);} break;

    /* numericka rada - casto se lisi US a UK */

		case SCANCODE_GRAVE:        //`~ (US) - ` mapped to sterling
		case SCANCODE_UK_BACKSLASH: //\| (UK)
      if(uskbd) {
        notshift {and(7,2); and(6,2);} ifelse and(4,1);
      } else {
        notshift {
          and(0,1); and(7,0x80);
        }	ifelse {
          relshift; and(7,2); and(4,2);
        }
      }
			break;

		case SCANCODE_2: //2@ (US) or 2" (UK)
			notshift {
        and(3,2);
			} ifelse {
				if(uskbd) and(3,2); else {relshift; and(5,0x40);}
			}                       
			break;

		case SCANCODE_3: //3# (US) or 3sterling (UK)
			notshift {
				and(3,4);
			} ifelse {
        if(uskbd) and(3,4); else {relshift; and(7,2); and(6,2);}
			}
			break;

    /************************************/

		case SCANCODE_6:
			notshift {
				and(4,0x10);
			}	ifelse {
        relshift; and(7,2); and(6,0x10);
			}
			break;

    case SCANCODE_7: notshift and(4,8); ifelse and(4,0x10); break;
		case SCANCODE_8: notshift and(4,4); ifelse and(4,0x40); break;
		case SCANCODE_9: notshift and(4,2); ifelse and(4,4);    break;
		case SCANCODE_0: notshift and(4,1); ifelse and(4,2);    break;

		/* <inv> and (c) keys are mapped to keypad <enter> and <.> */
		case SCANCODE_KEYPADENTER:  and(7,0x80); break;
		case SCANCODE_KEYPADPERIOD: and(0,1); and(5,0x40); break;

		default:
			if(ks<52) and(keytable[ks].port,~keytable[ks].bit);
			break;
	}
}

#undef uskbd

