/* 
 * ASCD : copyright (c) Aley Keprt 1998-2001
 *
 * File samkbd.c : Universal include file of ZXS keyboard handler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#define uskbd !cfg.uk


{
  switch (ks) {

		case SCANCODE_LEFTSHIFT:   //caps shift
    case SCANCODE_RIGHTSHIFT: and(0,1); shiftkey=pressed; break;

    case SCANCODE_LEFTALT:     //symbol shift
    case SCANCODE_RIGHTALT:     and(7,2); ctrlkey=pressed; break;

    //ctrl = joy fire or symbol shift if no joy emulation on arrows
		case SCANCODE_LEFTCONTROL:
    case SCANCODE_RIGHTCONTROL:
      if(cfg.kempston && cfg.cursor && cfg.fuller & cfg.sinclair1 && cfg.sinclair2) {
        //no joy emulation on arrows --> symbol shift
        and(7,2);
      } else {
        //joy emulation --> fire
        arrows.fire=pressed;
      }
      ctrlkey=pressed;
      break;

		case SCANCODE_SPACE:    and(7,1); break;
		case SCANCODE_KEYPADENTER:
    case SCANCODE_ENTER:    and(6,1); break;

    case SCANCODE_CAPSLOCK: and(0,1); and(3,2); break; //caps (shift+2)
		case SCANCODE_BACKSPACE:and(0,1); and(4,1); break; //delete (shift+0)

		case SCANCODE_CURSORBLOCKLEFT: arrows.left =pressed; break; //left (sh+5)
		case SCANCODE_CURSORBLOCKRIGHT:arrows.right=pressed; break; //right (sh+8)
		case SCANCODE_CURSORBLOCKUP:   arrows.up   =pressed; break; //up (sh+7)
		case SCANCODE_CURSORBLOCKDOWN: arrows.down =pressed; break; //down (sh+6)
/*
		case SCANCODE_CURSORBLOCKLEFT: and(0,1); and(3,0x10); arrows.left=pressed; break; //left (sh+5)
		case SCANCODE_CURSORBLOCKRIGHT:and(0,1); and(4,4); arrows.right=pressed; break; //right (sh+8)
		case SCANCODE_CURSORBLOCKUP:   and(0,1); and(4,8); arrows.up=pressed; break; //up (sh+7)
		case SCANCODE_CURSORBLOCKDOWN: and(0,1); and(4,0x10); arrows.down=pressed; break; //down (sh+6)
*/
		case SCANCODE_KEYPAD0: and(4,1); break;
		case SCANCODE_KEYPAD1: and(3,1); break;
		case SCANCODE_KEYPAD2: and(3,2); break;
		case SCANCODE_KEYPAD3: and(3,4); break;
		case SCANCODE_KEYPAD4: and(3,8); break;
		case SCANCODE_KEYPAD5: and(3,0x10); break;
		case SCANCODE_KEYPAD6: and(4,0x10); break;
		case SCANCODE_KEYPAD7: and(4,8); break;
		case SCANCODE_KEYPAD8: and(4,4); break;
		case SCANCODE_KEYPAD9: and(4,2); break;

    case SCANCODE_KEYPADDIVIDE:  and(7,2); and(0,0x10); break;
    case SCANCODE_KEYPADMULTIPLY:and(7,2); and(7,0x10); break;
    case SCANCODE_KEYPADMINUS:   and(7,2); and(6,8); break;
    case SCANCODE_KEYPADPLUS:    and(7,2); and(6,4); break;
    case SCANCODE_KEYPADPERIOD:  and(7,2); and(7,4); break;

    case SCANCODE_COMMA: //[,] (ss+n), [<] (ss+r)
      notshift {and(7,2); and(7,8);}
      break;

    case SCANCODE_PERIOD: //[.] (ss+m), [>] (ss+t)
      notshift {and(7,2); and(7,4);}
      break;

    case SCANCODE_SLASH: //[/] (ss+v), [?] (ss+c)
      notshift {and(7,2); and(0,0x10);}
      break;

		case SCANCODE_SEMICOLON: //[;] (ss+o), [:] (ss+z)
			notshift {and(7,2); and(5,2);}
/*
			} else { //:
	      keyports[7] &= 0xfd;
			  press(SCANCODE_Z);
			}
*/
			break;

		case SCANCODE_APOSTROPHE: //['] (ss+7), ["] (ss+p)
			notshift {and(7,2); and(4,8);}
/*
	      keyports[7] &= 0xfd;
			  press(SCANCODE_7);
			} else { //"
	      keyports[7] &= 0xfd;
			  press(SCANCODE_P);
			}
*/
			break;

    /* dve klavesy vedle 0 */

    case SCANCODE_MINUS: //[-] (ss+j), [_] (ss+0)
      notshift {and(7,2); and(6,8);}
      break;

    case SCANCODE_EQUAL: //[=] (ss+l), [+] (ss+k)
      notshift {and(7,2); and(6,2);}
      break;

    /* numericka rada - casto se lisi US a UK */

		case SCANCODE_GRAVE:        //`~ (US) - ` mapped to sterling
		case SCANCODE_UK_BACKSLASH: //\| (UK)
//      if(uskbd) {
        notshift {and(7,2); and(0,4);}// ifelse and(4,1);
/*
      } else {
        notshift {
          and(0,1); and(7,0x80);
        }	ifelse {
          relshift; and(7,2); and(4,2);
        }
      }
*/
			break;

		default:
			if(ks<52) and(keytable[ks].port,~keytable[ks].bit);
			break;
	}
}


#undef and
#undef pressed
#undef notshift
#undef ifelse
#undef relshift

#undef uskbd

